%HEADER%
%AS-HEADER-FAT%
#
mkdir $TMPDIR/$$
cd $TMPDIR/$$
#
# General Paths
#
S2DVERIF_DIR=%PATHS2DVERIF%
#
# Experiment description
#
EXPID=%EXPID%
CHUNKSIZE=%CHUNKSIZE%
NUMCHUNKS=%NUMCHUNKS%
START_date=%SDATE%
DATELIST="%DATELIST%"
IFSGRID=%IFS_resolution%
NEMGRID=%NEMO_resolution%
#
# Define a few addional variables
#
TEMPLATE=%TEMPLATE_NAME%
MODEL=${TEMPLATE/3}
case $MODEL in
  'ECEARTH' ) 
    lstvars1d=( 'sie' 'sia' 'siv' 'tos' 'tas' 'prlr' 'ohc' 'lohc' 'mohc' 'uohc' 'amoc' ) 
    lstvars2d=( 'tos' 'tas' 'prlr' ) 
    numfiles=`ls /cfunas/exp/ecearth/${EXPID}/monthly_mean/tas_*/*fc* | wc -l`
    ;;
  'IFS') 
    lstvars1d=( 'tos' 'tas' 'prlr' ) 
    lstvars2d=( 'tos' 'tas' 'prlr' ) 
    numfiles=`ls /cfunas/exp/ecearth/${EXPID}/monthly_mean/tas_*/*fc* | wc -l`
    ;;
  'NEMO') 
    lstvars1d=( 'sie' 'sia' 'siv' 'ohc' 'lohc' 'mohc' 'uohc' 'amoc' ) 
    lstvars2d=( ) 
    numfiles=`ls /cfunas/exp/ecearth/${EXPID}/monthly_mean/heatc/heatc* | wc -l`
    ;;
esac
NLTIMES=$(($NUMCHUNKS * $CHUNKSIZE))
START_month=$(echo $START_date | cut -c5-6)
YEAR0=${DATELIST:0:4}
YEARF=${DATELIST:$((${#DATELIST}-8)):4}
if [[ $YEAR0 -gt $YEARF ]] ; then YEAR0=$YEARF ; YEARF=${DATELIST:0:4} ; fi
INTSDATES=$((${DATELIST:9:4}-$YEAR0))
if [[ $INTSDATES -lt 0 ]] ; then INTSDATES=$((-1*$INTSDATES)) ; fi
if [[ $NLTIMES -lt 4 ]] ; then
  RUNMEANLEN=1
  lstseasons=( 'Year' )
  lstltimes=( 'ly1' )
elif [[ $NLTIMES -lt 7 ]] ; then
  RUNMEANLEN=1
  case $START_month in
    '11') lstseasons=( 'Year' 'DJF' ) ;;
    '02') lstseasons=( 'Year' 'MAM' ) ;;
    '05') lstseasons=( 'Year' 'JJA' ) ;;
    '08') lstseasons=( 'Year' 'SON' ) ;;
    *) lstseasons=( 'Year' )
  esac
  lstltimes=( 'ly1' )
elif [[ $NLTIMES -lt 10 ]] ; then
  RUNMEANLEN=3
  case $START_month in
    '11') lstseasons=( 'Year' 'DJF' 'MAM' ) ;;
    '02') lstseasons=( 'Year' 'MAM' 'JJA' ) ;;
    '05') lstseasons=( 'Year' 'JJA' 'SON' ) ;;
    '08') lstseasons=( 'Year' 'SON' 'DJF' ) ;;
    *) lstseasons=( 'Year' )
  esac
  lstltimes=( 'ly1' )
elif [[ $NLTIMES -lt 12 ]] ; then
  RUNMEANLEN=3
  case $START_month in
    '11') lstseasons=( 'Year' 'DJF' 'MAM' 'JJA' ) ;;
    '02') lstseasons=( 'Year' 'MAM' 'JJA' 'SON' ) ;;
    '05') lstseasons=( 'Year' 'JJA' 'SON' 'DJF' ) ;;
    '08') lstseasons=( 'Year' 'SON' 'DJF' 'MAM' ) ;;
    *) lstseasons=( 'Year' )
  esac
  lstltimes=( 'ly1' )
elif [[ $NLTIMES -lt 60 ]] ; then
  RUNMEANLEN=12
  lstseasons=( 'Year' 'JJA' 'SON' 'DJF' 'MAM' ) 
  lstltimes=( 'ly1' )
elif [[ $NLTIMES -lt 108 ]] ; then
  RUNMEANLEN=12
  lstseasons=( 'Year' 'JJA' 'SON' 'DJF' 'MAM' ) 
  lstltimes=( 'ly1' 'ly2-5' )
else
  RUNMEANLEN=12
  lstseasons=( 'Year' 'JJA' 'SON' 'DJF' 'MAM' ) 
  lstltimes=( 'ly1' 'ly2-5' 'ly6-9' )
fi
if [[ $MODEL == 'ECEARTH' ]] || [[ $MODEL == 'IFS' ]] ; then 
  case ${IFSGRID} in
   'T159L62') GRID='320x160' ;;
   'T255L91'|'T255L62') GRID='512x256' ;;
   'T511L91') GRID='1024x512' ;;
   'T799L62'|'T799L91') echo "Is the mask ready for this configuration?" ; stop ;;
  esac
fi
VERTNEM=L$(echo ${NEMGRID} | sed 's:ORCA\([0-9]*\)L\([0-9]*\):\2:')
if [[ $VERTNEM == 'LORCA1' ]] ; then VERTNEM='L42' ; fi
#
# Modify the arguments of plot_timeseries
#
cp ${S2DVERIF_DIR}/inst/doc/plot_timeseries.R .
sed -e "s/^lstexpid.*/lstexpid\ \<-\ c\(\'${EXPID}\'\)/1" plot_timeseries.R > tmp1
sed -e "s/^nltimemax.*/nltimemax\ \<-\ ${NLTIMES}/1" tmp1 > tmp2
sed -e "s/^nltimeout.*/nltimeout\ \<-\ ${NLTIMES}/1" tmp2 > tmp3
sed -e "s/^mon0.*/mon0\ \<-\ ${START_month}/1" tmp3 > tmp4
sed -e "s/^year0.*/year0\ \<-\ ${YEAR0}/1" tmp4 > tmp5
sed -e "s/^yearf.*/yearf\ \<-\ ${YEARF}/1" tmp5 > tmp6
sed -e "s/^intsdate.*/intsdate\ \<-\ ${INTSDATES}/1" tmp6 > tmp7
sed -e "s/^runmeanlen.*/runmeanlen\ \<-\ ${RUNMEANLEN}/1" tmp7 > plot_timeseries.R
rm -f tmp1 tmp2 tmp3 tmp4 tmp5 tmp6 tmp7
if [[ $MODEL == 'ECEARTH' ]] || [[ $MODEL == 'IFS' ]] ; then
  sed -e "s/^grid.*/grid\ \<-\ '${GRID}'/1" plot_timeseries.R > tmp1
  rm -f plot_timeseries.R
  mv tmp1 plot_timeseries.R
fi 
if [[ $MODEL == 'ECEARTH' ]] || [[ $MODEL == 'NEMO' ]] ; then
  sed -e "s/^vertnem.*/vertnem\ \<-\ '${VERTNEM}'/1" plot_timeseries.R > tmp1
  rm -f plot_timeseries.R
  mv tmp1 plot_timeseries.R
fi
if [[ $numfiles -lt 3 ]] ; then
  sed -e "s/^comptrend.*/comptrend\ \<-\ F/1" plot_timeseries.R > tmp1
  sed -e "s/^compcor.*/compcor\ \<-\ F/1" tmp1 > tmp2
  sed -e "s/^comprms.*/comprms\ \<-\ F/1" tmp2 > tmp3
  sed -e "s/^compspread.*/compspread\ \<-\ F/1" tmp3 > tmp4
  sed -e "s/^plotano.*/plotano\ \<-\ F/1" tmp4 > plot_timeseries.R
  rm -f tmp1 tmp2 tmp3 tmp4 tmp5
fi
chmod +x plot_timeseries.R
#
# Prepare the latex file to gather all figures in a pdf
#
cat > timeseries_${EXPID}.tex <<EOF1
\documentclass[a4paper,12pt]{article}
\usepackage{graphicx,graphics}
\pagestyle{empty}
\begin{document}

EOF1

function include_tab_series {
  filename=$1
  filenamebis=$2

  cat >> timeseries_${EXPID}.tex <<EOF2a
\begin{figure}[t]
\begin{center}
\begin{tabular}{c c}
\includegraphics[width=5cm,height=7cm,angle=-90]{${filename}.eps} & \includegraphics[width=5cm,height=7cm,angle=-90]{${filename}_smoothed.eps} \\
EOF2a

  if [[ $numfiles -ge 3 ]] ; then
    cat >> timeseries_${EXPID}.tex <<EOF2b
\includegraphics[width=5cm,height=7cm,angle=-90]{${filename}_ano.eps} & \includegraphics[width=5cm,height=7cm,angle=-90]{${filenamebis}_clim.eps} \\
\includegraphics[width=5cm,height=7cm,angle=-90]{cor_${filenamebis}.eps} & \includegraphics[width=5cm,height=7cm,angle=-90]{rms_${filenamebis}.eps} \\
\includegraphics[width=5cm,height=7cm,angle=-90]{IQR_${filenamebis}.eps} & \includegraphics[width=5cm,height=7cm,angle=-90]{SD_${filenamebis}.eps} \\
\includegraphics[width=5cm,height=7cm,angle=-90]{Mad_${filenamebis}.eps} & \includegraphics[width=5cm,height=7cm,angle=-90]{trend_${filenamebis}.eps} \\
EOF2b
  fi

  cat >> timeseries_${EXPID}.tex <<EOF2c
\end{tabular}
\end{center}
\end{figure}

EOF2c
}
#
# Launch the timeseries plotting
#
for var in ${lstvars1d[@]} ; do
  case $var in
    'sie'|'sia') 
      ./plot_timeseries.R $var N 
      include_tab_series ${var}_${EXPID}_N ${var}_N_${EXPID}
      ./plot_timeseries.R $var S &>> plot_timeseries.Rout
      include_tab_series ${var}_${EXPID}_S ${var}_S_${EXPID}
     ;;
    'siv') 
      ./plot_timeseries.R $var N 
      include_tab_series ${var}_${EXPID}_N ${var}_N_${EXPID}
     ;;
    *) 
      ./plot_timeseries.R $var 
      include_tab_series ${var}_${EXPID} ${var}_${EXPID} 
     ;; 
  esac
done
#
# Build the pdf gathering all timeseries
#
cat >> timeseries_${EXPID}.tex <<EOF3
\end{document}
EOF3
latex timeseries_${EXPID}.tex 
dvips -RO timeseries_${EXPID}.dvi -o timeseries_${EXPID}.eps
ps2pdf timeseries_${EXPID}.eps
cp -f timeseries_${EXPID}.pdf /cfu/autosubmit/i06x/plot/.
rm -f timeseries_${EXPID}*
#
# Modify the arguments of plot_maps
#
if [[ $numfiles -ge 3 ]] ; then
  cp ${S2DVERIF_DIR}/inst/doc/plot_maps.R .
  sed -e "s/^lstexpid.*/lstexpid\ \<-\ c\(\'${EXPID}\'\)/1" plot_maps.R > tmp1
  sed -e "s/^nltimemax.*/nltimemax\ \<-\ ${NLTIMES}/1" tmp1 > tmp2
  sed -e "s/^compratrms.*/compratrms\ \<-\ F/1" tmp2 > tmp3
  sed -e "s/^mon0.*/mon0\ \<-\ ${START_month}/1" tmp3 > tmp4
  sed -e "s/^year0.*/year0\ \<-\ ${YEAR0}/1" tmp4 > tmp5
  sed -e "s/^yearf.*/yearf\ \<-\ ${YEARF}/1" tmp5 > tmp6
  sed -e "s/^intsdate.*/intsdate\ \<-\ ${INTSDATES}/1" tmp6 > plot_maps.R
  rm -f tmp1 tmp2 tmp3 tmp4 tmp5 tmp6 
  chmod +x plot_maps.R
#
# Prepare the latex file to gather all figures in a pdf
#
  cat > maps_${EXPID}.tex <<EOF4
\documentclass[a4paper,12pt]{article}
\usepackage{graphicx,graphics}
\pagestyle{empty}
\begin{document}

EOF4

function include_tab_maps {
  filename=$1

  cat >> maps_${EXPID}.tex <<EOF5
\begin{figure}[t]
\begin{center}
\begin{tabular}{c c}
\includegraphics[width=5cm,height=7cm,angle=-90]{CorCoef2d_${filename}.eps} & \includegraphics[width=5cm,height=7cm,angle=-90]{RMSE2d_${filename}.eps} 
\end{tabular}
\includegraphics[width=5cm,height=7cm,angle=-90]{RMSSS2d_${filename}.eps} 
\end{center}
\end{figure}

EOF5
}
#
# Launch the maps plotting
#
  for var in ${lstvars2d[@]} ; do
    for seas in ${lstseasons[@]} ; do
      for ltimes ${lstltimes[@]} ; do
        ./plot_maps.R $var $seas $ltimes
        include_tab_maps ${var}_${EXPID}_${seas}_${ltimes} 
      done
    done
  done
#
# Build the pdf gathering all maps
#
  cat >> maps_${EXPID}.tex <<EOF6
\end{document}
EOF6
  latex maps_${EXPID}.tex 
  dvips -RO maps_${EXPID}.dvi -o maps_${EXPID}.eps
  ps2pdf maps_${EXPID}.eps
  cp -f maps_${EXPID}.pdf /cfu/autosubmit/i06x/plot/.
fi
#
#rm -rf $TMPDIR/$$
#
%AS-TAILER-FAT%

